//---------------------------------------------------------------------------
#include <windows.h>
#pragma hdrstop

#include <shlobj.h>
#include "dragdrop.h"
#include "sound.h"
#include "lcd.h"
#include "debsprite.h"
#include "gba.h"
#include "lregkey.h"
#include "bios.h"
#include "input.h"
#include "debug1.h"
#include "graphics.h"
#include "pluginctn.h"
#include "Unit1.h"
#include "linkcontrol.h"
#include "zipfile.h"
#include "trad.h"
#include "savestate.h"
#include "png.h"
#include "rtc.h"

#pragma link "C:\\lpng125\\projects\\borland\\libpngstat.lib"
//---------------------------------------------------------------------------
extern HWND hWin,hWndStatusBar;
extern DWORD dwlastTick,dwFrame,dwPriorityClass,bApplyIPSPath;
extern BOOL bLoadRecent,bRecordGame,bLoadCheatList,bEnableCheatList;
extern int RGSInterleave;
extern u8 bSincro,bAutoRun;
extern LList *pSaveStateList;
extern LRecentFile *pRecentFile;
extern LRESULT CALLBACK MainWindowProc(HWND win, UINT msg, WPARAM wparam, LPARAM lparam);
extern LSaveState rewindState;
static BOOL SavePNG(HBITMAP hBit,const char *lpFileName);
//---------------------------------------------------------------------------
static u8 nZoom;
static POINT ptOld;
BOOL bUsePNG;
//---------------------------------------------------------------------------
void UnregisterRBAClass(HINSTANCE this_inst)
{
   ::UnregisterClass("RASCALBOY",this_inst);
   UnregisterLinkControlClass(this_inst);
}
//---------------------------------------------------------------------------
BOOL RegisterRBAClass(HINSTANCE this_inst)
{
   WNDCLASS  wc;

   if(!GetClassInfo(this_inst,"RASCALBOY",&wc)){
       ZeroMemory(&wc,sizeof(WNDCLASS));
       wc.style = CS_HREDRAW | CS_VREDRAW;
       wc.lpfnWndProc = MainWindowProc;
       wc.hInstance = this_inst;
       wc.hIcon = LoadIcon(this_inst,MAKEINTRESOURCE(IDI_ICON1));
       wc.hCursor = LoadCursor(NULL,IDC_ARROW);
       wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
       wc.lpszMenuName =  MAKEINTRESOURCE(IDR_MAINFRAME);
       wc.lpszClassName = "RASCALBOY";
       if(!RegisterClass(&wc))
           return FALSE;
   }
   return RegisterLinkControlClass(this_inst);
}
//---------------------------------------------------------------------------
BOOL SaveConfig()
{
   LRegKey regKey;
   LString s;

   if(!regKey.Open("Software\\RascalBoy"))
       return FALSE;
   regKey.WriteLong("SRAMID",(DWORD)GetGamePackID());
   regKey.WriteLong("Zoom",(DWORD)nZoom);
   regKey.WriteLong("FrameBuffer",(DWORD)lcd.BlitMode);
   regKey.WriteLong("SkipFrame",(DWORD)SettaVelocita(100));
   regKey.WriteLong("cpuSpeed",(DWORD)EnableSpeedCPU(0xFFFF));
   regKey.WriteLong("Synchronize",(DWORD)bSincro);
   regKey.WriteLong("AutoStart",(DWORD)bAutoRun);
   regKey.WriteLong("UseBiosFile",(DWORD)UseBiosFile(FALSE));
   regKey.WriteLong("LoadMostRecentSaveState",(DWORD)bLoadRecent);
   regKey.WriteLong("RecordGame",(DWORD)bRecordGame);
   regKey.WriteLong("RecordGameInterleave",(DWORD)RGSInterleave);
   regKey.WriteLong("RecordGameMaxBuffer",(DWORD)rewindState.get_IndexMax());
   regKey.WriteLong("Priority",dwPriorityClass);
   s.Capacity(MAX_PATH);
   GetBiosFileName(s.c_str(),MAX_PATH - 1);
   regKey.WriteString("BiosFileName",s.c_str());
   s = "KeyConfig";
   if(mbID != 0)
       s += (int)mbID;
   regKey.WriteBinaryData(s.c_str(),GetKeyConfig(),10*sizeof(SHORT));
   regKey.WriteLong("SkipBiosIntro",SkipBiosIntro(FALSE));
   regKey.WriteLong("AutoLoadCheatList",(DWORD)MAKELONG(bLoadCheatList,bEnableCheatList));
   regKey.WriteLong("AutoIPSPatch",(DWORD)bApplyIPSPath);
   regKey.WriteLong("ScreenCapturePNG",(DWORD)bUsePNG);
   regKey.Close();
   return TRUE;
}
//---------------------------------------------------------------------------
BOOL LoadConfig()
{
   LRegKey regKey;
   LString s;
   DWORD dw;
   HMENU hMenu;

   hMenu = GetMenu(hWin);
   if(hMenu == NULL)
       return FALSE;
   if(!regKey.Open("Software\\RascalBoy"))
       return FALSE;
   SetPriorityClass(GetCurrentProcess(),(dwPriorityClass = (DWORD)regKey.ReadLong("Priority",NORMAL_PRIORITY_CLASS)));
   SetGamePackID((WORD)regKey.ReadLong("SRAMID",ID_SRAM_START));
   bLoadRecent = (BOOL)regKey.ReadLong("LoadMostRecentSaveState",0);
   CheckMenuItem(hMenu,ID_FILE_STATE_AUTOLOADMOSTRCNT,MF_BYCOMMAND|(bLoadRecent != 0 ? MF_CHECKED : MF_UNCHECKED));
   dw = (DWORD)regKey.ReadLong("AutoLoadCheatList",0);
   bLoadCheatList = LOWORD(dw);
   bEnableCheatList = HIWORD(dw);
   CheckMenuItem(hMenu,ID_FILE_CHEAT_AUTOLOAD,MF_BYCOMMAND|(bLoadCheatList != 0 ? MF_CHECKED : MF_UNCHECKED));
   CheckMenuItem(hMenu,ID_FILE_CHEAT_DISABLED,MF_BYCOMMAND|(bEnableCheatList == 0 ? MF_CHECKED : MF_UNCHECKED));
   bRecordGame = (BOOL)regKey.ReadLong("RecordGame",0);
   CheckMenuItem(hMenu,ID_FILE_STATE_RECORDGAME,MF_BYCOMMAND|(bRecordGame != 0 ? MF_CHECKED : MF_UNCHECKED));
   bApplyIPSPath = regKey.ReadLong("AutoIPSPatch",0);
   CheckMenuItem(hMenu,ID_APP_IPSPATCH,MF_BYCOMMAND|((WORD)bApplyIPSPath != 0 ? MF_CHECKED : MF_UNCHECKED));
   RGSInterleave = (int)regKey.ReadLong("RecordGameInterleave",3);
   rewindState.set_IndexMax((UINT)regKey.ReadLong("RecordGameMaxBuffer",5));
   nZoom = (u8)regKey.ReadLong("Zoom",1);
   ResizeWindow(nZoom);
   ChangeFrameBuffer((u8)regKey.ReadLong("FrameBuffer",BM_GDI));
   dw = regKey.ReadLong("SkipFrame",2);
   SettaVelocita((u8)dw);
	SetSyncro((u8)regKey.ReadLong("Synchronize",1));
   EnableSpeedCPU((WORD)CpuIncToID((int)regKey.ReadLong("cpuSpeed",0)));
   dw = (DWORD)GetKeyConfig();
   s = "KeyConfig";
   if(mbID != 0)
       s += (int)mbID;
   if(regKey.ReadBinaryData(s.c_str(),(char *)dw,10*sizeof(SHORT)) != 10 * sizeof(SHORT))
       regKey.ReadBinaryData("KeyConfig",(char *)dw,10*sizeof(SHORT));
   SetKeyConfig((char *)dw);
   SetBiosFileName(regKey.ReadString("BiosFileName","").c_str());
   SetUseBios((BOOL)regKey.ReadLong("UseBiosFile",0));
   SetSkipBiosIntro(regKey.ReadLong("SkipBiosIntro",0));
   SetAutoStart((int)regKey.ReadLong("AutoStart",0));
   bUsePNG = (BOOL)regKey.ReadLong("ScreenCapturePNG",FALSE);
   regKey.Close();
   return TRUE;
}
//---------------------------------------------------------------------------
int SetAutoStart(int value)
{
   if(value == -1)
       return bAutoRun;
   bAutoRun = (u8)(value & 1);
   CheckMenuItem(GetMenu(hWin),ID_EMU_AUTOSTART,MF_BYCOMMAND|(bAutoRun != 0 ? MF_CHECKED : MF_UNCHECKED));
   return bAutoRun;
}
//---------------------------------------------------------------------------
void ChangeFrameBuffer(u8 mode)
{
   int item[3],i;
   HMENU hMenu;

   if(lcd.BlitMode == BM_DIRECTDRAWFULLSCREEN && mode == BM_DIRECTDRAWFULLSCREEN)
       mode = BM_DIRECTDRAW;
   switch(mode){
       case BM_DIRECTDRAWFULLSCREEN:
           CloseDebugWindow();
           item[2] = ID_FRAMEBUFFER_DDRAW;
           item[1] = ID_FRAMEBUFFER_GDI;
           item[0] = ID_FRAMEBUFFER_DDRAWFULLSCREEN;
       break;
       case BM_DIRECTDRAW:
           item[0] = ID_FRAMEBUFFER_DDRAW;
           item[1] = ID_FRAMEBUFFER_GDI;
           item[2] = ID_FRAMEBUFFER_DDRAWFULLSCREEN;
       break;
       default:
           item[0] = ID_FRAMEBUFFER_GDI;
           item[1] = ID_FRAMEBUFFER_DDRAW;
           item[2] = ID_FRAMEBUFFER_DDRAWFULLSCREEN;
           mode = BM_GDI;
       break;
   }
   if(lcd.BlitMode != mode){
       if(mode == BM_GDI)
           ReleaseDirectDraw();
       else{
           if(!EnableDirectDraw(mode == BM_DIRECTDRAWFULLSCREEN)){
               ShowMessageError(TE_LCD);
               ReleaseDirectDraw();
               item[0] = ID_FRAMEBUFFER_GDI;
               item[1] = ID_FRAMEBUFFER_DDRAW;
               item[2] = ID_FRAMEBUFFER_DDRAWFULLSCREEN;
               mode = BM_GDI;
           }
       }
       i = 0;
       if(mode != BM_DIRECTDRAWFULLSCREEN && lcd.BlitMode == BM_DIRECTDRAWFULLSCREEN)
           i = 1;
       lcd.BlitMode = mode;
       if(i) ResizeWindow(1);
       if(bThreadRun && mode == BM_DIRECTDRAWFULLSCREEN)
           ExitWindowMode();
       i = mode == BM_DIRECTDRAWFULLSCREEN ? PIS_FULLSCREEN|PIS_DDRAW : (mode == BM_GDI ? 0 : PIS_DDRAW);
       pPlugInContainer->NotifyState(PIL_AUDIO|PIL_VIDEO,(DWORD)i,PIS_VIDEOMODEMASK);
   }
   hMenu = GetMenu(hWin);
   CheckMenuItem(hMenu,item[0],MF_BYCOMMAND|MF_CHECKED);
   CheckMenuItem(hMenu,item[1],MF_BYCOMMAND|MF_UNCHECKED);
   CheckMenuItem(hMenu,item[2],MF_BYCOMMAND|MF_UNCHECKED);
   for(i=0;i<512;i++)
       FillPalette((u16)i);
}
//---------------------------------------------------------------------------
int ParseCommandLine(char *pCommandLine)
{
   LString s,token,s1;
   int res,i;
   char ext[][5]={{".gba"},{".agb"},{".bin"}};

   token = s = pCommandLine;
   s.ResetToken();
   while(token.Length() > 0){
       token = s.NextToken(' ');
       if(token.Length() < 1){
           token = s.RemainderToken();
           if(token.Length() < 1)
               break;
       }
       s1 = token;
       s1.LowerCase();
       if(s1[1] == '-'){
           //comando
           s1.AllTrim();
//           if(s1 == "-resamplemix")
//               SetResampleFunction(1);
           if(s1 == "-nogbcsound")
               SetSoundGbcFunction(1);
           else if(s1 == "-nortc")
               EnableRTC(FALSE);
           else if(s1 == "-nobusdata")
           	EnableNewAccessBios(TRUE);
       }
   }
   s1 = pCommandLine;
   s1.LowerCase();
   res = 0;
   for(i=0;i<4;i++){
       if((res = s1.Pos(ext[i])) > 0)
           break;
   }
   if(i < 4){
       s1 = s1.SubString(1,res+3);
       s = s1.FileName();
       s += s1.SubString(res,s1.Length()-res+1);
       res = s1.Length() - s.Length();
       token = "";
       for(i=0;res > 1 && s1[res] != ' ';i++,res--);
       if(s1[res] == ' ')
           res++;
       s1 = s1.SubString(res,i);
       if(s1[i] != '\\')
           s1 += "\\";
       s1 += s;
       if(s1.Length() > 0){
           if(LoadRom(s1.c_str()))
               res = 1;
       }
   }
   return res;
}
//---------------------------------------------------------------------------
void RunDragDrop(int x,int y)
{
   IShellFolder *pIShellFolder;
   LPITEMIDLIST tmpDir;
   LString tmp;
   HRESULT hr;
   STRRET strRet;
   char s[MAX_PATH];
   HDC hdc;
   LDataObject *pIDataObject;
   LDropSource *pIDropSource;
   FORMATETC fetc = {CF_HDROP,NULL,DVASPECT_CONTENT,-1,TYMED_HGLOBAL};
   STGMEDIUM stgm = {0};
   DWORD dw,dwEffect;
   DROPFILES *df;

   if(nZoom > 2)
       return;
   if(ptOld.x == 0 && ptOld.y == 0){
       ptOld.x = x;
       ptOld.y = y;
       return;
   }
   if(abs(ptOld.x - x) < 30 || abs(ptOld.y - y) < 30)
       return;
   ptOld.x = x;
   ptOld.y = y;
   DragAcceptFiles(hWin,FALSE);
   PauseRestartSound(0);
   dwEffect = DROPEFFECT_MOVE;
   pIShellFolder = NULL;
   tmp = "";
   hdc = NULL;
   hr = SHGetSpecialFolderLocation(hWin,0x27,&tmpDir);
   pIDropSource = NULL;
   pIDataObject = NULL;
   if(hr == NOERROR){
       if(SHGetDesktopFolder(&pIShellFolder) == NOERROR){
           if(pIShellFolder->GetDisplayNameOf(tmpDir,SHGDN_FORPARSING,&strRet) == NOERROR){
               switch(strRet.uType){
                   case STRRET_CSTR:
                       tmp = strRet.cStr;
                   break;
                   case STRRET_OFFSET:
                       tmp = (char *)((char *)&strRet + strRet.uOffset);
                   break;
                   case STRRET_WSTR:
                       WideCharToMultiByte(CP_ACP,0,strRet.pOleStr,-1,s,MAX_PATH,NULL,NULL);
                       tmp = s;
                   break;
               }
           }
       }
   }
   if(tmp.IsEmpty()){
       if(!ExpandEnvironmentStrings("%TMP%",s,MAX_PATH)){
           if(!GetWindowsDirectory(s,MAX_PATH-1))
               goto ex_RunDragDrop;
           lstrcat(s,"\\Temp");
           dwEffect = DROPEFFECT_MOVE;
       }
       tmp = s;
   }
   if((hdc = CreateCompatibleDC(NULL)) == NULL)
       goto ex_RunDragDrop;
   SelectObject(hdc,lcd.hBitmap);
   DrawLcdBitmap(hdc);
   wsprintf(s,"RBA%08X",GetTickCount());
   if(tmp[tmp.Length()] != '\\')
       tmp += "\\";
   tmp += s;
   if(bUsePNG){
       tmp.AddEXT(".PNG");
       tmp.LowerCase();
       if(!SavePNG(lcd.hBitmap,tmp.c_str()))
           goto ex_RunDragDrop;
   }
   else{
       tmp.AddEXT(".BMP");
       if(!SaveBitmap(hdc,lcd.hBitmap,tmp.c_str()))
           goto ex_RunDragDrop;
   }
   if((pIDataObject = new LDataObject()) == NULL)
       goto ex_RunDragDrop;
   pIDataObject->AddRef();
   if((pIDropSource = new LDropSource()) == NULL)
       goto ex_RunDragDrop;
   pIDropSource->AddRef();
   stgm.tymed = TYMED_HGLOBAL;
   dw = sizeof(DROPFILES) + tmp.Length() * sizeof(wchar_t) + 40;
   if((stgm.hGlobal = GlobalAlloc(GPTR|GMEM_SHARE,dw)) == NULL)
       goto ex_RunDragDrop;
   df = (DROPFILES *)stgm.hGlobal;
   df->pFiles = (DWORD)(sizeof(DROPFILES));
   lstrcpy((LPTSTR)((char *)df + sizeof(DROPFILES)),tmp.c_str());
//   MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,tmp.c_str(),-1,(LPWSTR)((char *)df + sizeof(DROPFILES)),dw);
   pIDataObject->SetData(&fetc,&stgm,TRUE);
   hr = DoDragDrop(pIDataObject,pIDropSource,dwEffect,&dw);
   if(dwEffect == DROPEFFECT_MOVE)
       DeleteFile(tmp.c_str());
ex_RunDragDrop:
   ptOld.x = ptOld.y = 0;
   OleSetClipboard(NULL);
   OleFlushClipboard();
   if(pIDataObject != NULL)
       pIDataObject->Release();
   if(pIDropSource != NULL)
       pIDropSource->Release();
   if(pIShellFolder != NULL)
       pIShellFolder->Release();
   if(hdc != NULL)
       DeleteDC(hdc);
   dwlastTick = GetTickCount();
   dwFrame = 0;
   PauseRestartSound(0x11);
   DragAcceptFiles(hWin,TRUE);
}
//---------------------------------------------------------------------------
BOOL OnRButtonDown()
{
   HMENU hMenu,hMenu1;
   POINT pt;
   MENUITEMINFO mii;
   char s[50];
   LString s1,*pString;
   BOOL res;
   DWORD dwPos;
   int i;

   res = FALSE;
   EnterWindowMode();
   if((hMenu = CreatePopupMenu()) != NULL){
       GetCursorPos(&pt);
       ::ZeroMemory(&mii,sizeof(MENUITEMINFO));
       mii.cbSize = sizeof(MENUITEMINFO);
       mii.fMask = MIIM_TYPE;
       mii.fType = MFT_STRING;
       mii.dwTypeData = s;
       mii.cch = 49;
       ::GetMenuItemInfo(::GetMenu(hWin),ID_APP_LOAD,FALSE,&mii);
       AppendMenu(hMenu,MF_STRING|MF_ENABLED,ID_APP_LOAD,s);
       if(pSaveStateList != NULL && pSaveStateList->Count()){
           if((hMenu1 = CreatePopupMenu()) != NULL){
               s1 = TranslateGetMessage(ID_DLG0_FILE_STATE_LOAD);
               AppendMenu(hMenu,MF_ENABLED|MF_POPUP,(UINT)hMenu1,s1.c_str());
               OnInitMenuSaveState(hMenu1,POS_SM_SAVESTATE_LOAD);
           }
       }
       else
            hMenu1 = NULL;
       if(rewindState.Count() > 1){
           s1 = TranslateGetMessage(ID_FILE_STATE_REWINDGAME);
           AppendMenu(hMenu,MF_STRING|MF_ENABLED,ID_FILE_STATE_REWINDGAME,s1.c_str());
       }
       if(pRecentFile != NULL && pRecentFile->Count() > 0){
           AppendMenu(hMenu,MF_SEPARATOR,0,"");
           pString = (LString *)pRecentFile->GetLastItem(&dwPos);
           i = ID_FILE_RECENT + pRecentFile->Count() - 1;
           while(pString != NULL){
               AppendMenu(hMenu,MF_STRING,i,pString->c_str());
               pString = (LString *)pRecentFile->GetPrevItem(&dwPos);
               i--;
           }
       }
       TrackPopupMenu(hMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON,pt.x,pt.y,0,hWin,NULL);
       if(hMenu1 != NULL)
           DestroyMenu(hMenu1);
       DestroyMenu(hMenu);
       res = TRUE;
   }
   return res;
}
//---------------------------------------------------------------------------
void GetRBAWindowRect(LPRECT p)
{
   RECT rc;
   POINT pt;
   SIZE sz;

   sz.cx = p->right;
   sz.cy = p->bottom;
   GetWindowRect(hWin,&rc);
   pt.x = rc.right - rc.left;
   pt.y = rc.bottom - rc.top;
   GetClientRect(hWin,&rc);
   sz.cx += pt.x - rc.right;
   sz.cy += pt.y - rc.bottom;
   GetWindowRect(hWndStatusBar,&rc);
   sz.cy += rc.bottom - rc.top;
   pt.x = GetSystemMetrics(SM_CXFULLSCREEN) - sz.cx;
   pt.y = GetSystemMetrics(SM_CYFULLSCREEN) - sz.cy;
   if((pt.x & 0x80000000)) pt.x = 0;
   if((pt.y & 0x80000000)) pt.y = 0;
   p->left = pt.x >> 1;
   p->top = pt.y >> 1;
   p->right = sz.cx;
   p->bottom = sz.cy;
}
//---------------------------------------------------------------------------
BOOL ResizeWindow(u8 mode)
{
   HMENU hMenu;
   MENUITEMINFO mii;
   int item[3];
   RECT rc;

   if(lcd.BlitMode == BM_DIRECTDRAWFULLSCREEN)
       return TRUE;
   if(IsZoomed(hWin))
       ShowWindow(hWin,SW_RESTORE);
   hMenu = ::GetMenu(hWin);
   ZeroMemory(&mii,sizeof(MENUITEMINFO));
   mii.cbSize = sizeof(MENUITEMINFO);
   mii.fMask = MIIM_STATE;
   switch(mode){
       case 2:
           rc.right = 480;
           rc.bottom = 320;
           item[0] = ID_ZOOM_2;
           item[1] = ID_ZOOM_3;
           item[2] = ID_ZOOM_1;
       break;
       case 3:
           rc.right = 720;
           rc.bottom = 480;
           item[0] = ID_ZOOM_3;
           item[1] = ID_ZOOM_2;
           item[2] = ID_ZOOM_1;
       break;
       default:
           rc.right = 240;
           rc.bottom = 160;
           item[0] = ID_ZOOM_1;
           item[1] = ID_ZOOM_2;
           item[2] = ID_ZOOM_3;
           mode = 1;
       break;
   }
   mii.fState = MFS_CHECKED;
   SetMenuItemInfo(hMenu,item[0],FALSE,&mii);
   mii.fState = MFS_UNCHECKED;
   SetMenuItemInfo(hMenu,item[1],FALSE,&mii);
   SetMenuItemInfo(hMenu,item[2],FALSE,&mii);
   GetRBAWindowRect(&rc);
   ::SetWindowPos(hWin,NULL,rc.left,rc.top,rc.right,rc.bottom,SWP_NOZORDER);
   nZoom = mode;
   return TRUE;
}
//---------------------------------------------------------------------------
void OnApplyIPSPatch()
{
   char szFile[MAX_PATH];
   LFile *pFile;
   DWORD ofs;
   WORD bts;
   BYTE b;
   LString nameFile;

   *((LPDWORD)szFile) = 0;
   if(!nameFile.BuildFileName(bin.saveFileName,"ips"))
       return;
   pFile = new LFile(nameFile.c_str());
   if(pFile != NULL && pFile->Open())
       goto OnApplyIPSPatch_2;
   lstrcpy(szFile,nameFile.c_str());
   if((bApplyIPSPath >> 16) == 0)
       goto ex_OnApplyIPSPatch;
   if(!ShowOpenDialog(NULL,szFile,"IPS Files(*.ips)\0*.ips\0\0\0\0\0",hWin))
       goto ex_OnApplyIPSPatch;
   if(pFile != NULL)
       delete pFile;
   pFile = new LFile(szFile);
   if(pFile == NULL || !pFile->Open())
       return;
OnApplyIPSPatch_2:
   ((LPDWORD)szFile)[0] = ((LPDWORD)szFile)[1] = 0;
   pFile->Read(szFile,5);
   if(lstrcmpi(szFile,"PATCH") != 0)
       goto ex_OnApplyIPSPatch;
   do{
       ofs = 0;
       if(pFile->Read(&ofs,3) != 3)
           break;
       ofs = ((BYTE)ofs << 16) | (ofs & 0xFF00) | ((BYTE)(ofs >> 16));
       if(pFile->Read(&bts,2) != 2)
           break;
       bts = MAKEWORD(HIBYTE(bts),LOBYTE(bts));
       if(ofs == 0x454F46 && bts == 0x7FAB)
           break;
       if(!bts){
           if(pFile->Read(&bts,2) != 2)
               goto ex_OnApplyIPSPatch;
           bts = MAKEWORD(HIBYTE(bts),LOBYTE(bts));
           if(pFile->Read(&b,1) != 1)
               goto ex_OnApplyIPSPatch;
           for(;bts != 0;ofs++,bts--){
               if((ofs >> 16) > bin.maxIndex){
                   if((rom_pages_u8[(ofs >> 16)] = (unsigned char *)GlobalAlloc(GPTR,0x10000)) == NULL)
                       return;
                   bin.maxIndex++;
                   bin.rom_size_u8 += bts;
               }
               rom_pages_u8[(ofs >> 16)][(u16)ofs] = b;
           }
       }
       else{
           for(;bts != 0;ofs++,bts--){
               if(pFile->Read(&b,1) != 1)
                   goto ex_OnApplyIPSPatch;
               if((ofs >> 16) > bin.maxIndex){
                   if((rom_pages_u8[(ofs >> 16)] = (unsigned char *)GlobalAlloc(GPTR,0x10000)) == NULL)
                       return;
                   bin.maxIndex++;
                   bin.rom_size_u8 += bts;
               }
               rom_pages_u8[(ofs >> 16)][(u16)ofs] = b;
           }
       }
   }while(1);
ex_OnApplyIPSPatch:
   if(pFile != NULL)
       delete pFile;
}
//---------------------------------------------------------------------------
BOOL OnRButtonDownStatusBar()
{
   BOOL res;
   HMENU hMenu;
   char s[100];
   int i;
   POINT pt;
   MENUITEMINFO mii;
   
   res = FALSE;
   if((hMenu = CreatePopupMenu()) != NULL){
       GetCursorPos(&pt);
       for(i=ID_SRAM_START;i<= ID_EEPROM_END;i++){
           ::ZeroMemory(&mii,sizeof(MENUITEMINFO));
           mii.cbSize = sizeof(MENUITEMINFO);
           mii.fMask = MIIM_TYPE|MIIM_STATE;
           mii.fType = MFT_STRING;
           mii.dwTypeData = s;
           mii.cch = 99;
           ::GetMenuItemInfo(::GetMenu(hWin),i,FALSE,&mii);
           AppendMenu(hMenu,MF_STRING|MF_ENABLED|(mii.fState & MFS_CHECKED	? MF_CHECKED : MF_UNCHECKED),i,s);
       }
       TrackPopupMenu(hMenu,TPM_LEFTALIGN|TPM_LEFTBUTTON,pt.x,pt.y,0,hWin,NULL);
       DestroyMenu(hMenu);
       res = TRUE;
   }
   return res;
}
//---------------------------------------------------------------------------
void ResetMainPlugInMenu(HMENU hMenu)
{
   HMENU hSubMenu,hMenu1;
   int itemCount;

   hMenu1 = hMenu;
   if((hMenu = GetSubMenu(hMenu,2)) != NULL){
       hSubMenu = GetSubMenu(hMenu,POS_SM_SIOPLUGIN);
       if(hSubMenu != NULL){
           itemCount = GetMenuItemCount(hSubMenu)-1;
           for(;itemCount >= 0;itemCount--)
               DeleteMenu(hSubMenu,itemCount,MF_BYPOSITION);
       }
       hSubMenu = GetSubMenu(hMenu,POS_SM_AUDIOPLUGIN);
       if(hSubMenu != NULL){
           itemCount = GetMenuItemCount(hSubMenu)-1;
           for(;itemCount >= 0;itemCount--)
               DeleteMenu(hSubMenu,itemCount,MF_BYPOSITION);
       }
       hSubMenu = GetSubMenu(hMenu,POS_SM_VIDEOPLUGIN);
       if(hSubMenu != NULL){
           itemCount = GetMenuItemCount(hSubMenu)-1;
           for(;itemCount >= 0;itemCount--)
               DeleteMenu(hSubMenu,itemCount,MF_BYPOSITION);
      }
   }
   if((hMenu = GetSubMenu(hMenu1,0)) != NULL){
       hSubMenu = GetSubMenu(hMenu,POS_SM_LANGUAGE);
       if(hSubMenu != NULL){
           itemCount = GetMenuItemCount(hSubMenu)-1;
           for(;itemCount >= 0;itemCount--)
               DeleteMenu(hSubMenu,itemCount,MF_BYPOSITION);
       }
       hSubMenu = GetSubMenu(hMenu,POS_SM_FILESRECENT);
       if(hSubMenu != NULL){
           itemCount = GetMenuItemCount(hSubMenu)-1;
           for(;itemCount >= 1;itemCount--)
               DeleteMenu(hSubMenu,itemCount,MF_BYPOSITION);
       }
       hSubMenu = GetSubMenu(hMenu,POS_SM_BACKUP);
       if(hSubMenu != NULL){
           itemCount = GetMenuItemCount(hSubMenu)-1;
           for(;itemCount >= 1;itemCount--)
               DeleteMenu(hSubMenu,itemCount,MF_BYPOSITION);
       }
   }
   if((hSubMenu = GetSubMenu(hMenu,POS_SM_SAVESTATE)) != NULL){
       hMenu = hSubMenu;
       hSubMenu = GetSubMenu(hMenu,POS_SM_SAVESTATE_LOAD);
       if(hSubMenu != NULL){
           itemCount = GetMenuItemCount(hSubMenu)-1;
           for(;itemCount >= 0;itemCount--)
               DeleteMenu(hSubMenu,itemCount,MF_BYPOSITION);
       }
       hSubMenu = GetSubMenu(hMenu,POS_SM_SAVESTATE_SAVE);
       if(hSubMenu != NULL){
           itemCount = GetMenuItemCount(hSubMenu)-1;
           for(;itemCount >= 0;itemCount--)
               DeleteMenu(hSubMenu,itemCount,MF_BYPOSITION);
       }
   }
}
//---------------------------------------------------------------------------
void UpdateStatusBar(char *string,int index)
{
   if(lcd.bFullScreen == 2)
       return;
   if(index >= 0){
       SendMessage(hWndStatusBar,SB_SETTEXT,(WPARAM)index,(LPARAM)string);
       if(index == 2)
           SendMessage(hWndStatusBar,SB_SETTIPTEXT,(WPARAM)index,(LPARAM)&string[lstrlen(string)+1]);
   }
   else{
       SendMessage(hWndStatusBar,SB_SETTEXT,(WPARAM)0,(LPARAM)string);
       SendMessage(hWndStatusBar,SB_SETTEXT,(WPARAM)1,(LPARAM)string);
   }
}
//---------------------------------------------------------------------------
void OnPreResizeWindow(LPRECT rc2)
{
   RECT rc1,rc;

   GetClientRect(hWin,&rc);
   GetWindowRect(hWndStatusBar,&rc1);
   rc.bottom -= rc1.bottom - rc1.top;
   SetRectLcd(rc.right,rc.bottom);
   RecalcLayout();
   if(rc2 != NULL)
       CopyRect(rc2,&rc);
}
//---------------------------------------------------------------------------
void OnResizeWindow()
{
   RECT rc;
   UINT parts[3];

   OnPreResizeWindow(&rc);
   parts[0] = rc.right - 65;
   if(rc.right > 80)
       parts[0] -= 15;
   parts[1] = rc.right - 30;
   parts[2] = rc.right;
   ::SendMessage(hWndStatusBar,SB_SETPARTS,3,(LPARAM)(LPINT)parts);
}
//---------------------------------------------------------------------------
BOOL LoadBios()
{
   char szFile[MAX_PATH];
   LString c;

   if(bThreadRun)
       ::SendMessage(hWin,WM_COMMAND,MAKEWPARAM(ID_EMU_RESET,0),0);
   c = GetStringFromMenu(hWin,ID_APP_BIOS);
   MenuStringToString(c.c_str());
   *((LPDWORD)szFile) = 0;
   if(!ShowOpenDialog(c.c_str(),szFile,"Gameboy Advance files(*.rom,*.bin,*.gba,*.agb)\0*.rom;*.bin;*.gba;*.agb\0\0\0\0\0",hWin))
       return FALSE;
   return ResetBios(szFile);
}
//---------------------------------------------------------------------------
static BOOL SavePNG(HBITMAP hBit,const char *lpFileName)
{
   LFile *fp;
   BOOL res;
   BITMAP bm;
   png_structp png_ptr;
   png_infop info_ptr;
   short *p;
   png_bytep pixels,p1,*row_pointers;

   if(hBit == NULL || lpFileName == NULL)
       return FALSE;
   row_pointers = NULL;
   res = FALSE;
   fp = new LFile(lpFileName);
   if(fp == NULL || !fp->Open(GENERIC_READ|GENERIC_WRITE,CREATE_ALWAYS))
   	goto ex_SavePNG;
   if(GetObject(hBit,sizeof(BITMAP),&bm) != sizeof(BITMAP))
       goto ex_SavePNG;
   png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING,NULL,NULL,NULL);
   if(png_ptr == NULL)
       goto ex_SavePNG;
   info_ptr = png_create_info_struct(png_ptr);
   if(info_ptr == NULL)
       goto ex_SavePNG;
   png_init_io(png_ptr, fp->Handle());
   png_set_IHDR(png_ptr,info_ptr,bm.bmWidth,bm.bmHeight,8,PNG_COLOR_TYPE_RGB,
      PNG_INTERLACE_NONE,PNG_COMPRESSION_TYPE_BASE,PNG_FILTER_TYPE_BASE);
   png_write_info(png_ptr, info_ptr);
   row_pointers = (png_bytep *)GlobalAlloc(GPTR,3*bm.bmWidth*bm.bmHeight + (bm.bmHeight * sizeof(png_bytep)));
   if(row_pointers == NULL)
       goto ex_SavePNG;
   pixels = (png_bytep)(row_pointers + bm.bmHeight);
   p1 = pixels;
   p = (short *)bm.bmBits;
   for(int y = 0;y<bm.bmHeight;y++){
       row_pointers[y] = p1;
       for(int x=0;x<bm.bmWidth;x++,p++){
           *p1++ = (png_byte)(((*p >> 10) & 0x1f) << 3);
           *p1++ = (png_byte)(((*p >> 5) & 0x1f) << 3);
           *p1++ = (png_byte)((*p & 0x1f) << 3);
       }
   }
   png_write_image(png_ptr, row_pointers);
   png_write_end(png_ptr, info_ptr);
   png_destroy_write_struct(&png_ptr, &info_ptr);
   res = TRUE;
ex_SavePNG:
   png_destroy_write_struct(&png_ptr, &info_ptr);
   if(row_pointers != NULL)
       GlobalFree((HGLOBAL)row_pointers);
   if(fp != NULL)
       delete fp;
   return res;
}
